"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Unit = void 0;
const application_1 = require("./resources/application");
const cards_1 = require("./resources/cards");
const customer_1 = require("./resources/customer");
const transactions_1 = require("./resources/transactions");
const account_1 = require("./resources/account");
const customerToken_1 = require("./resources/customerToken");
const webhooks_1 = require("./resources/webhooks");
const batchAccounts_1 = require("./resources/batchAccounts");
const fee_1 = require("./resources/fee");
const helpers = __importStar(require("./helpers"));
const counterparty_1 = require("./resources/counterparty");
const events_1 = require("./resources/events");
const payments_1 = require("./resources/payments");
const authorization_1 = require("./resources/authorization");
const authorizationRequest_1 = require("./resources/authorizationRequest");
const statements_1 = require("./resources/statements");
const returns_1 = require("./resources/returns");
const applicationForm_1 = require("./resources/applicationForm");
const accountEndOfDay_1 = require("./resources/accountEndOfDay");
const resources_1 = require("./resources");
const institutions_1 = require("./resources/institutions");
const atmLocations_1 = require("./resources/atmLocations");
const checkDeposit_1 = require("./resources/checkDeposit");
const receivedPayments_1 = require("./resources/receivedPayments");
const recurringPayments_1 = require("./resources/recurringPayments");
const orgToken_1 = require("./resources/orgToken");
const simulations_1 = require("./resources/simulations");
const dispute_1 = require("./resources/dispute");
const repayments_1 = require("./resources/repayments");
const stopPayments_1 = require("./resources/stopPayments");
const chargeback_1 = require("./resources/chargeback");
class Unit {
    constructor(token, basePath, config) {
        // remove all trailing slashes from user-provided basePath
        basePath = basePath.trim().replace(/\/+$/, "");
        this.applications = new application_1.Applications(token, basePath, config);
        this.customers = new customer_1.Customers(token, basePath, config);
        this.accounts = new account_1.Accounts(token, basePath, config);
        this.accountsEndOfDay = new accountEndOfDay_1.AccountsEndOfDay(token, basePath, config);
        this.transactions = new transactions_1.Transactions(token, basePath, config);
        this.cards = new cards_1.Cards(token, basePath, config);
        this.webhooks = new webhooks_1.Webhooks(token, basePath, config);
        this.customerToken = new customerToken_1.CustomerTokens(token, basePath, config);
        this.batchAccount = new batchAccounts_1.BatchAccounts(token, basePath, config);
        this.fees = new fee_1.Fees(token, basePath, config);
        this.counterparties = new counterparty_1.Counterparties(token, basePath, config);
        this.events = new events_1.Events(token, basePath, config);
        this.payments = new payments_1.Payments(token, basePath, config);
        this.receivedPayments = new receivedPayments_1.ReceivedPayments(token, basePath, config);
        this.authorizations = new authorization_1.Authorizations(token, basePath, config);
        this.authorizationRequests = new authorizationRequest_1.AuthorizationRequests(token, basePath, config);
        this.statements = new statements_1.Statments(token, basePath, config);
        this.applicationForms = new applicationForm_1.ApplicationForms(token, basePath, config);
        this.returns = new returns_1.Returns(token, basePath, config);
        this.billPays = new resources_1.BillPays(token, basePath, config);
        this.institutions = new institutions_1.Institutions(token, basePath, config);
        this.atmLocations = new atmLocations_1.AtmLocations(token, basePath, config);
        this.checkDeposits = new checkDeposit_1.CheckDeposits(token, basePath, config);
        this.rewards = new resources_1.Rewards(token, basePath, config);
        this.recurringPayments = new recurringPayments_1.RecurringPayments(token, basePath, config);
        this.orgTokens = new orgToken_1.OrgTokens(token, basePath, config);
        this.simulations = new simulations_1.Simulations(token, basePath, config);
        this.disputes = new dispute_1.Disputes(token, basePath, config);
        this.repayments = new repayments_1.Repayments(token, basePath, config);
        this.stopPayments = new stopPayments_1.StopPayments(token, basePath, config);
        this.checkPayments = new resources_1.CheckPayments(token, basePath, config);
        this.chargebacks = new chargeback_1.Chargebacks(token, basePath, config);
        this.helpers = helpers;
    }
    isError(response) {
        // noinspection PointlessBooleanExpressionJS
        return response.isUnitError === true;
    }
}
exports.Unit = Unit;
__exportStar(require("./types"), exports);
__exportStar(require("./resources"), exports);
